# CustomerServiceIm
客服 Engine

## Usage
How to use my plugin.

## Installation

1. 在`Gemfile`里边添加如下代码
```ruby
gem 'customer_service_im'
```

2. 安装 gem 
```bash
$ bundle i
```

3. 执行 Engine 安装的命令
```bash
rails g customer_service_im:install
```

4. 修改`config/initializers/customer_service_im.rb`里边的配置信息，小程序配置和腾讯语音识别配置

5. 修改`config/cable.yml`中的配置，全部的 adapter 都改为 redis

```yml
development:
  adapter: redis
  url: <%= ENV.fetch("REDIS_URL") { "redis://localhost:6379/1" } %>

```

7. 安装 Engine 迁移
```bash
 rails customer_service_im:install:migrations
```

6. 安装 `ActiveStorage` ，如果宿主应用已安装则可跳过，操作冪等，可重复执行
```bash
rails active_storage:install
```

7. 执行迁移文件
```bash
rails db:migrate
```

8. 删除宿主应用的`app/channels`，目前没有好的解决方案，暂时先这样

9. 配置对应环境`websocket`域名白名单，如`config/initializers/development.rb`
```ruby
Rails.application.configure do
  # ...
  # config.action_cable.allowed_request_origins = [/http:\/\/*/, /https:\/\/*/]
  config.action_cable.allowed_request_origins = [/http:\/\/example\.com/, /https:\/\/example\.com/]
  # ...
end
```

10. 挂载 engine ，在`config/routes.rb`中添加
```ruby
mount CustomerServiceIm::Engine => "/customer_service"
```

11. 设置对应环境（如：`config/initializers/development.rb`）的默认 host 地址，用于拼接语音识别文件的 url 地址，必须外网能够访问
```ruby
Rails.application.configure do
  # ...
  Rails.application.routes.default_url_options[:host] = ENV.fetch("DEFAULT_HOST", "https://demo.mini-geek.com")
  # ...
end
```

12. 启用服务
```bash
$ rails s -b 0.0.0.0
```

## 部署注意事项

- 反向代理的配置
- redis 的配置
- `config/cable.yml`的配置

## Contributing
Contribution directions go here.

## License
The gem is available as open source under the terms of the [MIT License](https://opensource.org/licenses/MIT).
